package miniblog.page

import miniblog.*

class Login  {

  def exec( script, renderer, db )  {

    display = 'OCƓeł悤ɂȂ܂'

    if ( auth( script, db ) )  {
      script.session.login = new Date().toString()
      script.session.user  = script.params.name
      script.response.sendRedirect( 'post.groovy' )

    }  else  {

      if ( script.params.delete )  {
        try  {
          if ( script.params.pass1 == script.params.pass2 &&
               db.remove( new User( name:script.params.name, pass:script.params.pass1 ) ) )  {
            script.params.name = ''
            display = '[U[͍폜܂'
          }
        }  catch( ex )  {
          display = '[U[͍폜܂ł'
        }
      }

      def name = (script.params.name) ? script.params.name : ''
      def form = renderer.renderTemplate( Renderer.loginForm, ['name':name, 'display':display] )
      def messages = renderer.renderMessages( db.messages() )
      return renderer.renderTemplate( Renderer.HTML, ['body':form + messages] )

    }
  }

  private auth( script, db )  {
    if ( script.params.login == null )  return false
    if ( script.session.login != null )  return true
    def name  = script.params.name
    def pass1 = script.params.pass1
    def user = new User( name : name, pass : pass1 )
    if ( db.auth( user ) )  return true
    try  {
      def pass2 = script.params.pass2
      if ( pass1 == pass2  &&  name != pass1  &&
          [name, pass1].every { it =~ /^[a-zA-Z0-9]{6,}$/ } )  {
        return db.regist( user )
      }
    } catch( ex ) {}
    display = '[U[ƃpX[hmFĂ(pp6ȏ)'
    false
  }

  def display = ''

}