------------------------------------------
------------------------------------------
-- Groovyɂ~juOVXe̍\z
-- Copyright 2007 (C) Masanori OKIBAYASHI All rights Reserved.
------------------------------------------
------------------------------------------

--------------------------------
-- f[^x[Xgroovydb̍쐬
--------------------------------
DROP DATABASE IF EXISTS groovydb;

CREATE DATABASE groovydb;

CONNECT groovydb;

------------------
-- e[u`
------------------
-- [U[
CREATE TABLE user (
  id          INTEGER     PRIMARY KEY AUTO_INCREMENT,
  name        VARCHAR(30) NOT NULL UNIQUE,
  pass        BLOB        NOT NULL,
  date_create TIMESTAMP   DEFAULT CURRENT_TIMESTAMP,
  date_delete TIMESTAMP
);

-- eꂽbZ[W
CREATE TABLE miniblog (
  id          INTEGER      PRIMARY KEY AUTO_INCREMENT,
  user_id     INTEGER      NOT NULL REFERENCES user(id),
  message     VARCHAR(200) NOT NULL,
  date_create TIMESTAMP    DEFAULT CURRENT_TIMESTAMP
);

----------------------
-- f[^(Ql)
----------------------
INSERT INTO user (name, pass, date_create) VALUES ('masanori', PASSWORD('adminmin'), STR_TO_DATE( '2007-07-24 11:30:21', GET_FORMAT(DATETIME, 'JIS')));
INSERT INTO user (name, pass, date_create) VALUES ('okibayashi', PASSWORD('rootonton'), STR_TO_DATE( '2007-07-24 11:31:15', GET_FORMAT(DATETIME, 'JIS')));

INSERT INTO miniblog(user_id, message, date_create)
  VALUES (1, 'ЂƂ܂ŏ̃bZ[W', STR_TO_DATE( '2007-07-24 11:32:53', GET_FORMAT(DATETIME, 'JIS')));
INSERT INTO miniblog(user_id, message, date_create)
  VALUES (2, 'ʂ̃[U[̃bZ[W', STR_TO_DATE( '2007-07-24 11:33:24', GET_FORMAT(DATETIME, 'JIS')));
INSERT INTO miniblog(user_id, message, date_create)
  VALUES (1, 'VC', STR_TO_DATE( '2007-07-24 11:34:06', GET_FORMAT(DATETIME, 'JIS')));
INSERT INTO miniblog(user_id, message, date_create)
  VALUES (2, '!', STR_TO_DATE( '2007-07-24 11:34:22', GET_FORMAT(DATETIME, 'JIS')));
INSERT INTO miniblog(user_id, message, date_create)
  VALUES (1, 'VHׂĂ', STR_TO_DATE( '2007-07-24 11:35:13', GET_FORMAT(DATETIME, 'JIS')));
INSERT INTO miniblog(user_id, message, date_create)
  VALUES (2, 'ȂɐHׂ悤...', STR_TO_DATE( '2007-07-24 11:35:40', GET_FORMAT(DATETIME, 'JIS')));

SELECT * FROM user;
SELECT * FROM miniblog;

SELECT u.name, mb.message, mb.date_create FROM user u, miniblog mb WHERE u.id = mb.user_id ORDER BY u.name, mb.date_create;
