package miniblog.page

import miniblog.*

class Rss  {

  def encoding = 'UTF-8'
  def mimeType = 'application/rss+xml'

  def exec( script, renderer, db )  {

    renderer.renderTemplate( Renderer.RSS,
      [ 'encoding' : encoding,
        'title'    : 'GroovyŃ~juO',
        'link'     : Renderer.URL + 'rss.groovy',
        'desc'     : 'Groovyœ삷~juO',
        'year'     : 2007,
        'name'     : 'Masanori OKIBAYASHI',
        'date'     : Renderer.dateFormatter['us'].format( new Date() ),
        'items'    : renderer.renderItems( db.messages() ) ]
    )

  }

}